#Surface Data port

import Vector3D


class SurfData:
	verts = []
	faces = []
	normals = []
	numDecals = 0
	def __init__(self):
		pass
		
		
	def calculateNorms(self):
		self.normals = []
		for i in range(0, len(self.verts)):
			self.normals.append(Vector3D.Vector3D())
		
		for i in range(0, len(self.faces)):
			#print i
			#print self.faces[i]
			p0 = self.verts[self.faces[i][0]]
			p1 = self.verts[self.faces[i][1]]
			p2 = self.verts[self.faces[i][2]]			
		
			
			a = Vector3D.Vector3D(p0)
			b = Vector3D.Vector3D(p1)
			c = Vector3D.Vector3D(p2)
			a.subtract(p1)
			b.subtract(p2)
			c.subtract(p0)
			
			facenormal = a
			facenormal.cross(b)
			facenormal.normalize()
			
			if (self.normals[self.faces[i][0]] != None):
				self.normals[self.faces[i][0]].add(facenormal)
			else:
				self.normals[self.faces[i][0]] = facenormal
				
			if (self.normals[self.faces[i][1]] != None):
				self.normals[self.faces[i][1]].add(facenormal)
			else:
				self.normals[self.faces[i][1]] = facenormal
				
			if (self.normals[self.faces[i][2]] != None):
				self.normals[self.faces[i][2]].add(facenormal)
			else:
				self.normals[self.faces[i][2]] = facenormal
		
			
		for i in range(0, len(self.normals)):
			self.normals[i].normalize()
