import os
import sys
from tkinter import *
import tkFileDialog
from pymol import cmd

if(os.path.exists(os.getcwd() + '/Path_File.py')):
	import Path_File
else:
	FILE = open('Path_File.py', "w")
	FILE.writelines(["#this is the path file storage for the WiiMOl_Plugin -- do not delete or edit\n", "WiiMolPath = None"])
	print "made a new path file"
	FILE.close()
	import Path_File

filePath = os.getcwd()

if(Path_File.WiiMolPath != None):
	if(os.path.split(Path_File.WiiMolPath)[1] == 'WiiMOL_Main.py'):
		cmd.cd(os.path.split(Path_File.WiiMolPath)[0])
		import WiiMOL_Main

def __init__(self):
	self.menuBar.addcascademenu('Plugin','WiiMOL','WiiMOL',label = 'WiiMOL')
	self.menuBar.addmenuitem('WiiMOL','command','start WiiMOL', label = 'Start WiiMOL',command = lambda s = self: LoadWiiMOL(s))
	self.menuBar.addmenuitem('WiiMOL','command','new WiiMOL path', label = 'Set new WiiMOL path', command = lambda s = self: ModifyWiiPath(s))
	self.wiimol_running = False
                                     
                                   
def ModifyWiiPath(s):
	WiiMolPath = tkFileDialog.askopenfilename(defaultextension = '' ,  
						initialdir = 'C:\\', initialfile = '' , parent = s.root, title = 'please specify WiiMol_Main Location')
	if(os.path.split(WiiMolPath)[1] == 'WiiMOL_Main.py'):
		FILE = open(filePath + '\Path_File.py', "w")
		FILE.writelines(["#this is the path file storage for the WiiMOl_Plugin -- do not delete or edit\n", "WiiMolPath = '" + WiiMolPath + "'"])
		FILE.close()
		print "please restart pymol to use the new path."
	else:
		print "bad path - path not written"

def LoadWiiMOL(s):
	print filePath
	if(Path_File.WiiMolPath == None):
		WiiMolPath = tkFileDialog.askopenfilename(defaultextension = '' ,  
						initialdir = 'C:\\', initialfile = '' , parent = s.root, title = 'please specify WiiMol_Main Location')
		if(os.path.split(WiiMolPath)[1] == 'WiiMOL_Main.py'):
			FILE = open(filePath + '\Path_File.py', "w")
			FILE.writelines(["#this is the path file storage for the WiiMOl_Plugin -- do not delete or edit\n", "WiiMolPath = '" + WiiMolPath + "'"])
			FILE.close()
			print "please restart pymol to use the new path."
		else:
			print "bad path - path not written"
	if(Path_File.WiiMolPath != None and s.wiimol_running == False):
		s.wiimol_running = True
		if(os.path.split(Path_File.WiiMolPath)[1] == 'WiiMOL_Main.py'):
			cmd.cd(os.path.split(Path_File.WiiMolPath)[0])
			wiim = WiiMOL_Main.WiiMOL()
			WiiMOL_Main.WiiMOL.startTk(wiim,Tk())
	

cmd.extend('loadWiiMOL',LoadWiiMOL)
